declare type IState = string | number | boolean | undefined;
export interface IAction<T = IState> {
    toggle: (value?: T) => void;
    setLeft: () => void;
    setRight: () => void;
}
declare function useToggle<T = boolean | undefined>(): [T, IAction<T>];
declare function useToggle<T = IState>(defaultValue: T): [T, IAction<T>];
declare function useToggle<T = IState, U = IState>(defaultValue: T, reverseValue: U): [T | U, IAction<T | U>];
export default useToggle;
