import { ReactNode, FC } from 'react';
import { INoteTextHighlightInfoItem } from './getSelectedInfo';
import './asset/font/iconfont.css';
import './index.css';
interface IToolBarPaneProps {
    name: string;
    type: string;
    className?: string;
    icon?: ReactNode;
    render?: (props: any) => ReactNode;
}
export interface INoteTextHighlightInfo {
    list: INoteTextHighlightInfoItem[];
    text: string;
    mode?: string;
    [x: string]: any;
}
interface IOnChangeProps {
    action: 'add' | 'update';
    data: {
        list: INoteTextHighlightInfoItem[];
        text: string;
        [x: string]: any;
    };
    mode?: string;
}
export interface INote {
    template: string;
    value?: INoteTextHighlightInfo[];
    tagName?: string;
    attrName?: string;
    splitAttrName?: string;
    onChange: (props: IOnChangeProps) => void;
    rowKey?: string;
    toolBarList?: IToolBarPaneProps[];
    renderToolBar?: (a: any) => ReactNode;
    filterToolBar?: (option: IToolBarPaneProps, selected?: INoteTextHighlightInfo) => boolean;
    hasDefaultToolBar?: boolean;
}
declare const Note: FC<INote>;
export default Note;
